﻿Imports System.Diagnostics

Public Class Form1
    ' Display information about the current process's memory usage.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim proc As Process = Process.GetCurrentProcess()
        AddItem(lvMemory, "Min Working Set", (CDbl(proc.MinWorkingSet).ToFileSize()))
        AddItem(lvMemory, "Max Working Set", (CDbl(proc.MaxWorkingSet).ToFileSize()))
        AddItem(lvMemory, "Non-paged Memory Size", (CDbl(proc.NonpagedSystemMemorySize64).ToFileSize()))
        AddItem(lvMemory, "Paged Memory Size", (CDbl(proc.PagedMemorySize64).ToFileSize()))
        AddItem(lvMemory, "Paged System Memory Size", (CDbl(proc.PagedSystemMemorySize64).ToFileSize()))
        AddItem(lvMemory, "Peak Paged Memory Size", (CDbl(proc.PeakPagedMemorySize64).ToFileSize()))
        AddItem(lvMemory, "Peak Virtual Memory Size", (CDbl(proc.PeakVirtualMemorySize64).ToFileSize()))
        AddItem(lvMemory, "Peak Working Set", (CDbl(proc.PeakWorkingSet64).ToFileSize()))
        AddItem(lvMemory, "Virtual Memory Size", (CDbl(proc.VirtualMemorySize64).ToFileSize()))
        AddItem(lvMemory, "Working Set", (CDbl(proc.WorkingSet64).ToFileSize()))

        lvMemory.Columns(0).AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent)
        lvMemory.Columns(1).AutoResize(ColumnHeaderAutoResizeStyle.ColumnContent)
    End Sub

    ' Add an item to the ListView.
    Private Sub AddItem(ByVal lv As ListView, ByVal item_name As String, ByVal item_value As String)
        Dim lv_item As ListViewItem = lv.Items.Add(item_name)
        lv_item.SubItems.Add(item_value)
    End Sub
End Class
